unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Edit1: TEdit;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Edit10: TEdit;
    Edit11: TEdit;
    Label13: TLabel;
    Label14: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button4: TButton;
    Button1: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Label20: TLabel;
    Edit20: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Edit14Change(Sender: TObject);
    procedure Edit15Change(Sender: TObject);
    procedure Edit16Change(Sender: TObject);
    procedure Edit17Change(Sender: TObject);
    procedure Edit18Change(Sender: TObject);
    procedure Edit19Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Edit10Change(Sender: TObject);
    procedure Edit11Change(Sender: TObject);
    procedure Edit12Change(Sender: TObject);
    procedure Edit13Change(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button15Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  ORDERLINES=20;
  WAYS=200;
  TANKS=200;
  HOUSES=200;


type
  TWay = record
           x1,y1,x2,y2:single;
           typ:single;
         end;
  TTank = record
            x, y, owner, typ, target, tx, ty, mustdie, mustsurvive, nogoal, noorders:single;
          end;
  THouse = record
             x, y, owner, typ, a, mustdie, mustsurvive, nogoal, noorders:single;
           end;
  TLight = record
             x1,y1,z1,r1,g1,b1:single;
             x2,y2,z2,r2,g2,b2:single;
           end;
  TGoal = record
            mustdie, mustsurvive, killall, location, killlocation, banlocation:single;
            lx,ly,lr:single;
            kx,ky,kr:single;
            bx,by,br:single;
          end;
  TMission = record
               fname:string;
               name, next:string;
               orders:array [1..ORDERLINES] of string;
               ordlen, tanknum, housenum, waynum:integer;
               ways:array [1..WAYS] of TWay;
               tanks:array[1..TANKS] of TTank;
               houses:array[1..HOUSES] of THouse;
               light:TLight;
               goal:TGoal;
               startx, starty:single;
             end;
  TView = record
            x,y, zoom:single;
          end;
  TSelect = record
              typ, obj:integer;
            end;
  TDrag = record
            left, right:boolean;
            x, y:single;
          end;

var
  Form1: TForm1;
  mission: TMission;
  view:TView;
  inner:boolean;
  select:TSelect;
  drag:TDrag;

implementation

{$R *.DFM}

procedure initinput;
begin
  if select.typ=-1 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='Prop 1:';
    Form1.Label3.Enabled:=false;
    Form1.Edit2.Text:='';
    Form1.Edit2.Enabled:=false;
    Form1.Label4.Caption:='Prop 2:';
    Form1.Label4.Enabled:=false;
    Form1.Edit3.Text:='';
    Form1.Edit3.Enabled:=false;
    Form1.Label5.Caption:='Prop 3:';
    Form1.Label5.Enabled:=false;
    Form1.Edit4.Text:='';
    Form1.Edit4.Enabled:=false;
    Form1.Label6.Caption:='Prop 4:';
    Form1.Label6.Enabled:=false;
    Form1.Edit5.Text:='';
    Form1.Edit5.Enabled:=false;
    Form1.Label7.Caption:='Prop 5:';
    Form1.Label7.Enabled:=false;
    Form1.Edit6.Text:='';
    Form1.Edit6.Enabled:=false;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=1 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='Prop 1:';
    Form1.Label3.Enabled:=false;
    Form1.Edit2.Text:='';
    Form1.Edit2.Enabled:=false;
    Form1.Label4.Caption:='Prop 2:';
    Form1.Label4.Enabled:=false;
    Form1.Edit3.Text:='';
    Form1.Edit3.Enabled:=false;
    Form1.Label5.Caption:='Prop 3:';
    Form1.Label5.Enabled:=false;
    Form1.Edit4.Text:='';
    Form1.Edit4.Enabled:=false;
    Form1.Label6.Caption:='Prop 4:';
    Form1.Label6.Enabled:=false;
    Form1.Edit5.Text:='';
    Form1.Edit5.Enabled:=false;
    Form1.Label7.Caption:='Prop 5:';
    Form1.Label7.Enabled:=false;
    Form1.Edit6.Text:='';
    Form1.Edit6.Enabled:=false;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=true;
    Form1.Label15.Caption:='Mission name:';
    Form1.Edit14.Enabled:=true;
    Form1.Edit14.Text:=mission.name;
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=3 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='Prop 1:';
    Form1.Label3.Enabled:=false;
    Form1.Edit2.Text:='';
    Form1.Edit2.Enabled:=false;
    Form1.Label4.Caption:='Prop 2:';
    Form1.Label4.Enabled:=false;
    Form1.Edit3.Text:='';
    Form1.Edit3.Enabled:=false;
    Form1.Label5.Caption:='Prop 3:';
    Form1.Label5.Enabled:=false;
    Form1.Edit4.Text:='';
    Form1.Edit4.Enabled:=false;
    Form1.Label6.Caption:='Prop 4:';
    Form1.Label6.Enabled:=false;
    Form1.Edit5.Text:='';
    Form1.Edit5.Enabled:=false;
    Form1.Label7.Caption:='Prop 5:';
    Form1.Label7.Enabled:=false;
    Form1.Edit6.Text:='';
    Form1.Edit6.Enabled:=false;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=true;
    Form1.Label15.Caption:='Mission orders:';
    Form1.Edit14.Enabled:=true;
    Form1.Edit14.Text:=mission.orders[1];
    Form1.Edit15.Enabled:=true;
    Form1.Edit15.Text:=mission.orders[2];
    Form1.Edit16.Enabled:=true;
    Form1.Edit16.Text:=mission.orders[3];
    Form1.Edit17.Enabled:=true;
    Form1.Edit17.Text:=mission.orders[4];
    Form1.Edit18.Enabled:=true;
    Form1.Edit18.Text:=mission.orders[5];
    Form1.Edit19.Enabled:=true;
    Form1.Edit19.Text:=mission.orders[6];
  end;
  if select.typ=5 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='dont use:';
    Form1.Label3.Enabled:=true;
    Form1.Edit2.Text:=floattostr(mission.goal.mustsurvive);
    Form1.Edit2.Enabled:=true;
    Form1.Label4.Caption:='dont use:';
    Form1.Label4.Enabled:=true;
    Form1.Edit3.Text:=floattostr(mission.goal.mustdie);
    Form1.Edit3.Enabled:=true;
    Form1.Label5.Caption:='loc x:';
    Form1.Label5.Enabled:=true;
    Form1.Edit4.Text:=floattostr(mission.goal.lx);
    Form1.Edit4.Enabled:=true;
    Form1.Label6.Caption:='loc y:';
    Form1.Label6.Enabled:=true;
    Form1.Edit5.Text:=floattostr(mission.goal.ly);
    Form1.Edit5.Enabled:=true;
    Form1.Label7.Caption:='loc r:';
    Form1.Label7.Enabled:=true;
    Form1.Edit6.Text:=floattostr(mission.goal.lr);
    Form1.Edit6.Enabled:=true;
    Form1.Label8.Caption:='kill x:';
    Form1.Label8.Enabled:=true;
    Form1.Edit7.Text:=floattostr(mission.goal.kx);
    Form1.Edit7.Enabled:=true;
    Form1.Label9.Caption:='kill y:';
    Form1.Label9.Enabled:=true;
    Form1.Edit8.Text:=floattostr(mission.goal.ky);
    Form1.Edit8.Enabled:=true;
    Form1.Label10.Caption:='kill r:';
    Form1.Label10.Enabled:=true;
    Form1.Edit9.Text:=FloatToStr((mission.goal.kr));
    Form1.Edit9.Enabled:=true;
    Form1.Label11.Caption:='ban x:';
    Form1.Label11.Enabled:=true;
    Form1.Edit10.Text:=FloatToStr((mission.goal.bx));
    Form1.Edit10.Enabled:=true;
    Form1.Label12.Caption:='ban y:';
    Form1.Label12.Enabled:=true;
    Form1.Edit11.Text:=FloatToStr((mission.goal.by));
    Form1.Edit11.Enabled:=true;
    Form1.Label13.Caption:='ban r:';
    Form1.Label13.Enabled:=true;
    Form1.Edit12.Text:=FloatToStr((mission.goal.br));
    Form1.Edit12.Enabled:=true;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Kill all enemies:';
    Form1.Label16.Enabled:=true;
    Form1.CheckBox1.Enabled:=true;
    if mission.goal.killall=-1 then begin
      Form1.CheckBox1.Checked:=false;
    end else begin
      Form1.CheckBox1.Checked:=true;
    end;
    Form1.Label17.Caption:='Go to location:';
    Form1.Label17.Enabled:=true;
    Form1.CheckBox2.Enabled:=true;
    if mission.goal.location=-1 then begin
      Form1.CheckBox2.Checked:=false;
    end else begin
      Form1.CheckBox2.Checked:=true;
    end;
    Form1.Label18.Caption:='Clear location:';
    Form1.Label18.Enabled:=true;
    Form1.CheckBox3.Enabled:=true;
    if mission.goal.killlocation=-1 then begin
      Form1.CheckBox3.Checked:=false;
    end else begin
      Form1.CheckBox3.Checked:=true;
    end;
    Form1.Label19.Caption:='Keep enemies out:';
    Form1.Label19.Enabled:=true;
    Form1.CheckBox4.Enabled:=true;
    if mission.goal.banlocation=-1 then begin
      Form1.CheckBox4.Checked:=false;
    end else begin
      Form1.CheckBox4.Checked:=true;
    end;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=6 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='Prop 1:';
    Form1.Label3.Enabled:=false;
    Form1.Edit2.Text:='';
    Form1.Edit2.Enabled:=false;
    Form1.Label4.Caption:='Prop 2:';
    Form1.Label4.Enabled:=false;
    Form1.Edit3.Text:='';
    Form1.Edit3.Enabled:=false;
    Form1.Label5.Caption:='Prop 3:';
    Form1.Label5.Enabled:=false;
    Form1.Edit4.Text:='';
    Form1.Edit4.Enabled:=false;
    Form1.Label6.Caption:='Prop 4:';
    Form1.Label6.Enabled:=false;
    Form1.Edit5.Text:='';
    Form1.Edit5.Enabled:=false;
    Form1.Label7.Caption:='Prop 5:';
    Form1.Label7.Enabled:=false;
    Form1.Edit6.Text:='';
    Form1.Edit6.Enabled:=false;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=true;
    Form1.Label15.Caption:='Next mission filename:';
    Form1.Edit14.Enabled:=true;
    Form1.Edit14.Text:=mission.next;
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=7 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='x 1:';
    Form1.Label3.Enabled:=true;
    Form1.Edit2.Text:=FloatToStr((mission.light.x1));
    Form1.Edit2.Enabled:=true;
    Form1.Label4.Caption:='x 2:';
    Form1.Label4.Enabled:=true;
    Form1.Edit3.Text:=FloatToStr((mission.light.x2));
    Form1.Edit3.Enabled:=true;
    Form1.Label5.Caption:='y 1:';
    Form1.Label5.Enabled:=true;
    Form1.Edit4.Text:=FloatToStr((mission.light.y1));
    Form1.Edit4.Enabled:=true;
    Form1.Label6.Caption:='y 2:';
    Form1.Label6.Enabled:=true;
    Form1.Edit5.Text:=FloatToStr((mission.light.y2));
    Form1.Edit5.Enabled:=true;
    Form1.Label7.Caption:='z 1:';
    Form1.Label7.Enabled:=true;
    Form1.Edit6.Text:=FloatToStr((mission.light.z1));
    Form1.Edit6.Enabled:=true;
    Form1.Label8.Caption:='z 2:';
    Form1.Label8.Enabled:=true;
    Form1.Edit7.Text:=FloatToStr((mission.light.z2));
    Form1.Edit7.Enabled:=true;
    Form1.Label9.Caption:='red 1:';
    Form1.Label9.Enabled:=true;
    Form1.Edit8.Text:=FloatToStr((mission.light.r1));
    Form1.Edit8.Enabled:=true;
    Form1.Label10.Caption:='red 2:';
    Form1.Label10.Enabled:=true;
    Form1.Edit9.Text:=FloatToStr((mission.light.r2));
    Form1.Edit9.Enabled:=true;
    Form1.Label11.Caption:='green 1:';
    Form1.Label11.Enabled:=true;
    Form1.Edit10.Text:=FloatToStr((mission.light.g1));
    Form1.Edit10.Enabled:=true;
    Form1.Label12.Caption:='green 2:';
    Form1.Label12.Enabled:=true;
    Form1.Edit11.Text:=FloatToStr((mission.light.g2));
    Form1.Edit11.Enabled:=true;
    Form1.Label13.Caption:='blue 1:';
    Form1.Label13.Enabled:=true;
    Form1.Edit12.Text:=FloatToStr((mission.light.b1));
    Form1.Edit12.Enabled:=true;
    Form1.Label14.Caption:='blue 2:';
    Form1.Label14.Enabled:=true;
    Form1.Edit13.Text:=FloatToStr((mission.light.b2));
    Form1.Edit13.Enabled:=true;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=8 then begin
    Form1.Edit20.Text:=IntToStr(select.obj-1);
    Form1.Label3.Caption:='owner:';
    Form1.Label3.Enabled:=true;
    Form1.Edit2.Text:=FloatToStr((mission.tanks[select.obj].owner));
    Form1.Edit2.Enabled:=true;
    Form1.Label4.Caption:='type:';
    Form1.Label4.Enabled:=true;
    Form1.Edit3.Text:=FloatToStr((mission.tanks[select.obj].typ));
    Form1.Edit3.Enabled:=true;
    Form1.Label5.Caption:='x:';
    Form1.Label5.Enabled:=true;
    Form1.Edit4.Text:=FloatToStr((mission.tanks[select.obj].x));
    Form1.Edit4.Enabled:=true;
    Form1.Label6.Caption:='y:';
    Form1.Label6.Enabled:=true;
    Form1.Edit5.Text:=FloatToStr((mission.tanks[select.obj].y));
    Form1.Edit5.Enabled:=true;
    Form1.Label7.Caption:='target:';
    Form1.Label7.Enabled:=true;
    Form1.Edit6.Text:=FloatToStr((mission.tanks[select.obj].target));
    Form1.Edit6.Enabled:=true;
    Form1.Label8.Caption:='target x:';
    Form1.Label8.Enabled:=true;
    Form1.Edit7.Text:=FloatToStr((mission.tanks[select.obj].tx));
    Form1.Edit7.Enabled:=true;
    Form1.Label9.Caption:='target y:';
    Form1.Label9.Enabled:=true;
    Form1.Edit8.Text:=FloatToStr((mission.tanks[select.obj].ty));
    Form1.Edit8.Enabled:=true;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='No orders:';
    Form1.Label16.Enabled:=true;
    Form1.CheckBox1.Enabled:=true;
    if mission.tanks[select.obj].noorders=-1 then begin
      Form1.CheckBox1.Checked:=false;
    end else begin
      Form1.CheckBox1.Checked:=true;
    end;
    Form1.Label17.Caption:='Ignore as goal:';
    Form1.Label17.Enabled:=true;
    Form1.CheckBox2.Enabled:=true;
    if mission.tanks[select.obj].nogoal=-1 then begin
      Form1.CheckBox2.Checked:=false;
    end else begin
      Form1.CheckBox2.Checked:=true;
    end;
    Form1.Label18.Caption:='Must die:';
    Form1.Label18.Enabled:=true;
    Form1.CheckBox3.Enabled:=true;
    if mission.tanks[select.obj].mustdie=-1 then begin
      Form1.CheckBox3.Checked:=false;
    end else begin
      Form1.CheckBox3.Checked:=true;
    end;
    Form1.Label19.Caption:='Must survive:';
    Form1.Label19.Enabled:=true;
    Form1.CheckBox4.Enabled:=true;
    if mission.tanks[select.obj].mustsurvive=-1 then begin
      Form1.CheckBox4.Checked:=false;
    end else begin
      Form1.CheckBox4.Checked:=true;
    end;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=9 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='start x:';
    Form1.Label3.Enabled:=true;
    Form1.Edit2.Text:=FloatToStr((mission.startx));
    Form1.Edit2.Enabled:=true;
    Form1.Label4.Caption:='start y:';
    Form1.Label4.Enabled:=true;
    Form1.Edit3.Text:=FloatToStr((mission.starty));
    Form1.Edit3.Enabled:=true;
    Form1.Label5.Caption:='Prop 3:';
    Form1.Label5.Enabled:=false;
    Form1.Edit4.Text:='';
    Form1.Edit4.Enabled:=false;
    Form1.Label6.Caption:='Prop 4:';
    Form1.Label6.Enabled:=false;
    Form1.Edit5.Text:='';
    Form1.Edit5.Enabled:=false;
    Form1.Label7.Caption:='Prop 5:';
    Form1.Label7.Enabled:=false;
    Form1.Edit6.Text:='';
    Form1.Edit6.Enabled:=false;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=10 then begin
    Form1.Edit20.Text:=IntToStr(mission.tanknum+select.obj-1);
    Form1.Label3.Caption:='owner:';
    Form1.Label3.Enabled:=true;
    Form1.Edit2.Text:=FloatToStr((mission.houses[select.obj].owner));
    Form1.Edit2.Enabled:=true;
    Form1.Label4.Caption:='type:';
    Form1.Label4.Enabled:=true;
    Form1.Edit3.Text:=FloatToStr((mission.houses[select.obj].typ));
    Form1.Edit3.Enabled:=true;
    Form1.Label5.Caption:='x:';
    Form1.Label5.Enabled:=true;
    Form1.Edit4.Text:=FloatToStr((mission.houses[select.obj].x));
    Form1.Edit4.Enabled:=true;
    Form1.Label6.Caption:='y:';
    Form1.Label6.Enabled:=true;
    Form1.Edit5.Text:=FloatToStr((mission.houses[select.obj].y));
    Form1.Edit5.Enabled:=true;
    Form1.Label7.Caption:='a:';
    Form1.Label7.Enabled:=true;
    Form1.Edit6.Text:=FloatToStr((mission.houses[select.obj].a));
    Form1.Edit6.Enabled:=true;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='No orders:';
    Form1.Label16.Enabled:=true;
    Form1.CheckBox1.Enabled:=true;
    if mission.houses[select.obj].noorders=-1 then begin
      Form1.CheckBox1.Checked:=false;
    end else begin
      Form1.CheckBox1.Checked:=true;
    end;
    Form1.Label17.Caption:='Ignore as goal:';
    Form1.Label17.Enabled:=true;
    Form1.CheckBox2.Enabled:=true;
    if mission.houses[select.obj].nogoal=-1 then begin
      Form1.CheckBox2.Checked:=false;
    end else begin
      Form1.CheckBox2.Checked:=true;
    end;
    Form1.Label18.Caption:='Must die:';
    Form1.Label18.Enabled:=true;
    Form1.CheckBox3.Enabled:=true;
    if mission.houses[select.obj].mustdie=-1 then begin
      Form1.CheckBox3.Checked:=false;
    end else begin
      Form1.CheckBox3.Checked:=true;
    end;
    Form1.Label19.Caption:='Must survive:';
    Form1.Label19.Enabled:=true;
    Form1.CheckBox4.Enabled:=true;
    if mission.houses[select.obj].mustsurvive=-1 then begin
      Form1.CheckBox4.Checked:=false;
    end else begin
      Form1.CheckBox4.Checked:=true;
    end;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  if select.typ=11 then begin
    Form1.Edit20.Text:='';
    Form1.Label3.Caption:='x 1:';
    Form1.Label3.Enabled:=true;
    Form1.Edit2.Text:=FloatToStr((mission.ways[select.obj].x1));
    Form1.Edit2.Enabled:=true;
    Form1.Label4.Caption:='x 2:';
    Form1.Label4.Enabled:=true;
    Form1.Edit3.Text:=FloatToStr((mission.ways[select.obj].x2));
    Form1.Edit3.Enabled:=true;
    Form1.Label5.Caption:='y 1:';
    Form1.Label5.Enabled:=true;
    Form1.Edit4.Text:=FloatToStr((mission.ways[select.obj].y1));
    Form1.Edit4.Enabled:=true;
    Form1.Label6.Caption:='y 2:';
    Form1.Label6.Enabled:=true;
    Form1.Edit5.Text:=FloatToStr((mission.ways[select.obj].y2));
    Form1.Edit5.Enabled:=true;
    Form1.Label7.Caption:='type:';
    Form1.Label7.Enabled:=true;
    Form1.Edit6.Text:=FloatToStr((mission.ways[select.obj].typ));
    Form1.Edit6.Enabled:=true;
    Form1.Label8.Caption:='Prop 6:';
    Form1.Label8.Enabled:=false;
    Form1.Edit7.Text:='';
    Form1.Edit7.Enabled:=false;
    Form1.Label9.Caption:='Prop 7:';
    Form1.Label9.Enabled:=false;
    Form1.Edit8.Text:='';
    Form1.Edit8.Enabled:=false;
    Form1.Label10.Caption:='Prop 8:';
    Form1.Label10.Enabled:=false;
    Form1.Edit9.Text:='';
    Form1.Edit9.Enabled:=false;
    Form1.Label11.Caption:='Prop 9:';
    Form1.Label11.Enabled:=false;
    Form1.Edit10.Text:='';
    Form1.Edit10.Enabled:=false;
    Form1.Label12.Caption:='Prop 10:';
    Form1.Label12.Enabled:=false;
    Form1.Edit11.Text:='';
    Form1.Edit11.Enabled:=false;
    Form1.Label13.Caption:='Prop 11:';
    Form1.Label13.Enabled:=false;
    Form1.Edit12.Text:='';
    Form1.Edit12.Enabled:=false;
    Form1.Label14.Caption:='Prop 12:';
    Form1.Label14.Enabled:=false;
    Form1.Edit13.Text:='';
    Form1.Edit13.Enabled:=false;
    Form1.Label16.Caption:='Tag 1:';
    Form1.Label16.Enabled:=false;
    Form1.CheckBox1.Enabled:=false;
    Form1.CheckBox1.Checked:=false;
    Form1.Label17.Caption:='Tag 2:';
    Form1.Label17.Enabled:=false;
    Form1.CheckBox2.Enabled:=false;
    Form1.CheckBox2.Checked:=false;
    Form1.Label18.Caption:='Tag 3:';
    Form1.Label18.Enabled:=false;
    Form1.CheckBox3.Enabled:=false;
    Form1.CheckBox3.Checked:=false;
    Form1.Label19.Caption:='Tag 4:';
    Form1.Label19.Enabled:=false;
    Form1.CheckBox4.Enabled:=false;
    Form1.CheckBox4.Checked:=false;
    Form1.Label15.Enabled:=false;
    Form1.Label15.Caption:='Text lines:';
    Form1.Edit14.Enabled:=false;
    Form1.Edit14.Text:='';
    Form1.Edit15.Enabled:=false;
    Form1.Edit15.Text:='';
    Form1.Edit16.Enabled:=false;
    Form1.Edit16.Text:='';
    Form1.Edit17.Enabled:=false;
    Form1.Edit17.Text:='';
    Form1.Edit18.Enabled:=false;
    Form1.Edit18.Text:='';
    Form1.Edit19.Enabled:=false;
    Form1.Edit19.Text:='';
  end;
  Form1.Paint;
end;

procedure loadmission(fname:string);
var
  f:file;
  typ:word;
  b:char;
  i:integer;
begin
  mission.fname:=fname;
  AssignFile(f, fname);
  Reset(f, 1);
  mission.ordlen:=0;
  for i:=1 to 6 do mission.orders[i]:='';
  mission.tanknum:=0;
  mission.housenum:=0;
  mission.waynum:=0;
  mission.next:='';
  mission.startx:=144;
  mission.starty:=144;
  mission.light.x1:=0;
  mission.light.y1:=0;
  mission.light.z1:=1;
  mission.light.r1:=0;
  mission.light.g1:=0.35;
  mission.light.b1:=0.55;
  mission.light.x2:=1;
  mission.light.y2:=0;
  mission.light.z2:=0.5;
  mission.light.r2:=0.75;
  mission.light.g2:=0.25;
  mission.light.b2:=0.2;
  while not eof(f) do begin
    blockread(f, typ, 2);
    if typ=1 then begin
      mission.name:='';
      blockread(f, b, 1);
      if b<>chr(0) then mission.name:=mission.name+b;
      while b<>chr(0) do begin
        blockread(f, b, 1);
        if b<>chr(0) then mission.name:=mission.name+b;
      end;
    end;
    if typ=2 then begin
      inc(mission.tanknum);
      blockread(f, mission.tanks[mission.tanknum].owner, 4);
      blockread(f, mission.tanks[mission.tanknum].typ, 4);
      blockread(f, mission.tanks[mission.tanknum].x, 4);
      blockread(f, mission.tanks[mission.tanknum].y, 4);
      mission.tanks[mission.tanknum].target:=-1;
      mission.tanks[mission.tanknum].tx:=0;
      mission.tanks[mission.tanknum].ty:=0;
      mission.tanks[mission.tanknum].mustdie:=-1;
      mission.tanks[mission.tanknum].mustsurvive:=-1;
      mission.tanks[mission.tanknum].nogoal:=-1;
      mission.tanks[mission.tanknum].noorders:=-1;
    end;
    if typ=3 then begin
      inc(mission.ordlen);
      mission.orders[mission.ordlen]:='';
      blockread(f, b, 1);
      if b<>chr(0) then mission.orders[mission.ordlen]:=mission.orders[mission.ordlen]+b;
      while b<>chr(0) do begin
        blockread(f, b, 1);
        if b<>chr(0) then mission.orders[mission.ordlen]:=mission.orders[mission.ordlen]+b;
      end;
    end;
    if typ=4 then begin
      inc(mission.waynum);
      blockread(f, mission.ways[mission.waynum].x1, 4);
      blockread(f, mission.ways[mission.waynum].y1, 4);
      blockread(f, mission.ways[mission.waynum].x2, 4);
      blockread(f, mission.ways[mission.waynum].y2, 4);
      mission.ways[mission.waynum].typ:=0;
    end;
    if typ=5 then begin
      blockread(f, mission.goal.mustsurvive, 4);
      blockread(f, mission.goal.mustdie, 4);
      blockread(f, mission.goal.killall, 4);
      blockread(f, mission.goal.location, 4);
      blockread(f, mission.goal.killlocation, 4);
      blockread(f, mission.goal.banlocation, 4);
      blockread(f, mission.goal.lx, 4);
      blockread(f, mission.goal.ly, 4);
      blockread(f, mission.goal.lr, 4);
      blockread(f, mission.goal.kx, 4);
      blockread(f, mission.goal.ky, 4);
      blockread(f, mission.goal.kr, 4);
      blockread(f, mission.goal.bx, 4);
      blockread(f, mission.goal.by, 4);
      blockread(f, mission.goal.br, 4);
    end;
    if typ=6 then begin
      mission.next:='';
      blockread(f, b, 1);
      if b<>chr(0) then mission.next:=mission.next+b;
      while b<>chr(0) do begin
        blockread(f, b, 1);
        if b<>chr(0) then mission.next:=mission.next+b;
      end;
    end;
    if typ=7 then begin
      blockread(f, mission.light.x1, 4);
      blockread(f, mission.light.y1, 4);
      blockread(f, mission.light.z1, 4);
      blockread(f, mission.light.r1, 4);
      blockread(f, mission.light.g1, 4);
      blockread(f, mission.light.b1, 4);
      blockread(f, mission.light.x2, 4);
      blockread(f, mission.light.y2, 4);
      blockread(f, mission.light.z2, 4);
      blockread(f, mission.light.r2, 4);
      blockread(f, mission.light.g2, 4);
      blockread(f, mission.light.b2, 4);
    end;
    if typ=8 then begin
      inc(mission.tanknum);
      blockread(f, mission.tanks[mission.tanknum].owner, 4);
      blockread(f, mission.tanks[mission.tanknum].typ, 4);
      blockread(f, mission.tanks[mission.tanknum].x, 4);
      blockread(f, mission.tanks[mission.tanknum].y, 4);
      blockread(f, mission.tanks[mission.tanknum].target, 4);
      blockread(f, mission.tanks[mission.tanknum].tx, 4);
      blockread(f, mission.tanks[mission.tanknum].ty, 4);
      blockread(f, mission.tanks[mission.tanknum].noorders, 4);
      blockread(f, mission.tanks[mission.tanknum].nogoal, 4);
      blockread(f, mission.tanks[mission.tanknum].mustsurvive, 4);
      blockread(f, mission.tanks[mission.tanknum].mustdie, 4);
    end;
    if typ=9 then begin
      blockread(f, mission.startx, 4);
      blockread(f, mission.starty, 4);
    end;
    if typ=10 then begin
      inc(mission.housenum);
      blockread(f, mission.houses[mission.housenum].owner, 4);
      blockread(f, mission.houses[mission.housenum].typ, 4);
      blockread(f, mission.houses[mission.housenum].x, 4);
      blockread(f, mission.houses[mission.housenum].y, 4);
      blockread(f, mission.houses[mission.housenum].a, 4);
      blockread(f, mission.houses[mission.housenum].noorders, 4);
      blockread(f, mission.houses[mission.housenum].nogoal, 4);
      blockread(f, mission.houses[mission.housenum].mustsurvive, 4);
      blockread(f, mission.houses[mission.housenum].mustdie, 4);
    end;
    if typ=11 then begin
      inc(mission.waynum);
      blockread(f, mission.ways[mission.waynum].x1, 4);
      blockread(f, mission.ways[mission.waynum].y1, 4);
      blockread(f, mission.ways[mission.waynum].x2, 4);
      blockread(f, mission.ways[mission.waynum].y2, 4);
      blockread(f, mission.ways[mission.waynum].typ, 4);
    end;
  end;
  mission.ordlen:=6;
  CloseFile(f);
  view.x:=mission.startx;
  view.y:=mission.starty;
  view.zoom:=4;
  inner:=true;
  select.typ:=-1;
  initinput;
end;

procedure SaveMission;
var
  f:file;
  typ:word;
  b:char;
  i:integer;
begin
  AssignFile(f, mission.fname);
  Rewrite(f, 1);
  typ:=1;
  blockwrite(f, typ, 2);
  blockwrite(f, mission.name[1], length(mission.name));
  b:=chr(0);
  blockwrite(f, b, 1);
  for i:=1 to mission.ordlen do begin
    typ:=3;
    blockwrite(f, typ, 2);
    blockwrite(f, mission.orders[i][1], length(mission.orders[i]));
    b:=chr(0);
    blockwrite(f, b, 1);
  end;
  typ:=5;
  blockwrite(f, typ, 2);
  blockwrite(f, mission.goal.mustsurvive, 4);
  blockwrite(f, mission.goal.mustdie, 4);
  blockwrite(f, mission.goal.killall, 4);
  blockwrite(f, mission.goal.location, 4);
  blockwrite(f, mission.goal.killlocation, 4);
  blockwrite(f, mission.goal.banlocation, 4);
  blockwrite(f, mission.goal.lx, 4);
  blockwrite(f, mission.goal.ly, 4);
  blockwrite(f, mission.goal.lr, 4);
  blockwrite(f, mission.goal.kx, 4);
  blockwrite(f, mission.goal.ky, 4);
  blockwrite(f, mission.goal.kr, 4);
  blockwrite(f, mission.goal.bx, 4);
  blockwrite(f, mission.goal.by, 4);
  blockwrite(f, mission.goal.br, 4);
  if mission.next<>'' then begin
    typ:=6;
    blockwrite(f, typ, 2);
    blockwrite(f, mission.next[1], length(mission.next));
    b:=#0;
    blockwrite(f, b, 1);
  end;
  typ:=7;
  blockwrite(f, typ, 2);
  blockwrite(f, mission.light.x1, 4);
  blockwrite(f, mission.light.y1, 4);
  blockwrite(f, mission.light.z1, 4);
  blockwrite(f, mission.light.r1, 4);
  blockwrite(f, mission.light.g1, 4);
  blockwrite(f, mission.light.b1, 4);
  blockwrite(f, mission.light.x2, 4);
  blockwrite(f, mission.light.y2, 4);
  blockwrite(f, mission.light.z2, 4);
  blockwrite(f, mission.light.r2, 4);
  blockwrite(f, mission.light.g2, 4);
  blockwrite(f, mission.light.b2, 4);
  for i:=1 to mission.tanknum do begin
    typ:=8;
    blockwrite(f, typ, 2);
    blockwrite(f, mission.tanks[i].owner, 4);
    blockwrite(f, mission.tanks[i].typ, 4);
    blockwrite(f, mission.tanks[i].x, 4);
    blockwrite(f, mission.tanks[i].y, 4);
    blockwrite(f, mission.tanks[i].target, 4);
    blockwrite(f, mission.tanks[i].tx, 4);
    blockwrite(f, mission.tanks[i].ty, 4);
    blockwrite(f, mission.tanks[i].noorders, 4);
    blockwrite(f, mission.tanks[i].nogoal, 4);
    blockwrite(f, mission.tanks[i].mustsurvive, 4);
    blockwrite(f, mission.tanks[i].mustdie, 4);
  end;
  typ:=9;
  blockwrite(f, typ, 2);
  blockwrite(f, mission.startx, 4);
  blockwrite(f, mission.starty, 4);
  for i:=1 to mission.housenum do begin
    typ:=10;
    blockwrite(f, typ, 2);
    blockwrite(f, mission.houses[i].owner, 4);
    blockwrite(f, mission.houses[i].typ, 4);
    blockwrite(f, mission.houses[i].x, 4);
    blockwrite(f, mission.houses[i].y, 4);
    blockwrite(f, mission.houses[i].a, 4);
    blockwrite(f, mission.houses[i].noorders, 4);
    blockwrite(f, mission.houses[i].nogoal, 4);
    blockwrite(f, mission.houses[i].mustsurvive, 4);
    blockwrite(f, mission.houses[i].mustdie, 4);
  end;
  for i:=1 to mission.waynum do begin
    typ:=11;
    blockwrite(f, typ, 2);
    blockwrite(f, mission.ways[i].x1, 4);
    blockwrite(f, mission.ways[i].y1, 4);
    blockwrite(f, mission.ways[i].x2, 4);
    blockwrite(f, mission.ways[i].y2, 4);
    blockwrite(f, mission.ways[i].typ, 4);
  end;
  CloseFile(f);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  loadmission(Edit1.Text);
end;

procedure DrawQuad(x, y, a, dx, dy:single);
var rx, ry:single;
begin
  rx:=x-0.5*dx*cos(a)-(-0.5*dy*sin(a));
  ry:=y-0.5*dy*cos(a)+(-0.5*dx*sin(a));
  Form1.Image1.Canvas.MoveTo(trunc((rx-view.x)*view.zoom/255.0*400)+200, 400-(trunc((ry-view.y)*view.zoom/255.0*400)+200));
  rx:=x+0.5*dx*cos(a)-(-0.5*dy*sin(a));
  ry:=y-0.5*dy*cos(a)+(0.5*dx*sin(a));
  Form1.Image1.Canvas.LineTo(trunc((rx-view.x)*view.zoom/255.0*400)+200, 400-(trunc((ry-view.y)*view.zoom/255.0*400)+200));
  rx:=x+0.5*dx*cos(a)-(0.5*dy*sin(a));
  ry:=y+0.5*dy*cos(a)+(0.5*dx*sin(a));
  Form1.Image1.Canvas.LineTo(trunc((rx-view.x)*view.zoom/255.0*400)+200, 400-(trunc((ry-view.y)*view.zoom/255.0*400)+200));
  rx:=x-0.5*dx*cos(a)-(0.5*dy*sin(a));
  ry:=y+0.5*dy*cos(a)+(-0.5*dx*sin(a));
  Form1.Image1.Canvas.LineTo(trunc((rx-view.x)*view.zoom/255.0*400)+200, 400-(trunc((ry-view.y)*view.zoom/255.0*400)+200));
  rx:=x-0.5*dx*cos(a)-(-0.5*dy*sin(a));
  ry:=y-0.5*dy*cos(a)+(-0.5*dx*sin(a));
  Form1.Image1.Canvas.LineTo(trunc((rx-view.x)*view.zoom/255.0*400)+200, 400-(trunc((ry-view.y)*view.zoom/255.0*400)+200));
end;

procedure TForm1.FormPaint(Sender: TObject);
var i:integer;
    xsize, ysize:single;
begin
  {small map}
  Image2.Canvas.Pen.Color:=$FFFFFF;
  Image2.Canvas.Brush.Color:=$FFFFFF;
  Image2.Canvas.Rectangle(0,0,200,200);
  Image2.Canvas.Pen.Color:=$E0E0E0;
  Image2.Canvas.Brush.Color:=$E0E0E0;
  if inner then begin
    Image2.Canvas.Rectangle(trunc((view.x-255.0/view.zoom/2.0)/255.0*200),
                            trunc(200-(view.y-255.0/view.zoom/2.0)/255.0*200),
                            trunc((view.x+255.0/view.zoom/2.0)/255.0*200),
                            trunc(200-(view.y+255.0/view.zoom/2.0)/255.0*200));
    for i:=1 to mission.waynum do begin
      if mission.ways[i].typ=0 then Image2.Canvas.Pen.width:=3;
      if mission.ways[i].typ>0 then Image2.Canvas.Pen.width:=2;
      Image2.Canvas.Pen.Color:=$D0FFD0;
      Image2.Canvas.MoveTo(trunc((mission.ways[i].x1)/255.0*200), 200-(trunc((mission.ways[i].y1)/255.0*200)));
      Image2.Canvas.LineTo(trunc((mission.ways[i].x2)/255.0*200), 200-(trunc((mission.ways[i].y2)/255.0*200)));
    end;
    Image2.Canvas.Pen.width:=1;
    Image2.Canvas.Pen.Color:=$0000FF;
    Image2.Canvas.Brush.Color:=$0000FF;
    Image2.Canvas.Ellipse(trunc((mission.startx)/255.0*200)-2, 200-(trunc((mission.starty)/255.0*200))-2,
                          trunc((mission.startx)/255.0*200)+2, 200-(trunc((mission.starty)/255.0*200))+2);
    Image2.Canvas.Pen.Color:=$000000;
    for i:=1 to mission.tanknum do begin
      Image2.Canvas.Pixels[trunc((mission.tanks[i].x)/255.0*200), 200-(trunc((mission.tanks[i].y)/255.0*200))]:=$000000;
    end;
    for i:=1 to mission.housenum do begin
      Image2.Canvas.Pixels[trunc((mission.houses[i].x)/255.0*200), 200-(trunc((mission.houses[i].y)/255.0*200))]:=$000000;
    end;
  end else begin
    Image2.Canvas.Rectangle(trunc((view.x-144-255.0/view.zoom/2.0)/1000.0*200)+100,
                            200-(trunc((view.y-144-255.0/view.zoom/2.0)/1000.0*200)+100),
                            trunc((view.x-144+255.0/view.zoom/2.0)/1000.0*200)+100,
                            200-(trunc((view.y-144+255.0/view.zoom/2.0)/1000.0*200)+100));
    Image2.Canvas.Brush.Color:=$FFFFFF;
    Image2.Canvas.Rectangle(trunc((0-144)/1000.0*200)+100, 200-(trunc((0-144)/1000.0*200)+100),
                            trunc((255.0-144)/1000.0*200)+100, 200-(trunc((255.0-144)/1000.0*200)+100));
    for i:=1 to mission.waynum do begin
      if mission.ways[i].typ=0 then Image2.Canvas.Pen.width:=3;
      if mission.ways[i].typ>0 then Image2.Canvas.Pen.width:=2;
      Image2.Canvas.Pen.Color:=$D0FFD0;
      Image2.Canvas.MoveTo(trunc((mission.ways[i].x1-144)/1000.0*200)+100, 200-(trunc((mission.ways[i].y1-144)/1000.0*200)+100));
      Image2.Canvas.LineTo(trunc((mission.ways[i].x2-144)/1000.0*200)+100, 200-(trunc((mission.ways[i].y2-144)/1000.0*200)+100));
    end;
    Image2.Canvas.Pen.width:=1;
    Image2.Canvas.Pen.Color:=$0000FF;
    Image2.Canvas.Brush.Color:=$0000FF;
    Image2.Canvas.Ellipse(trunc((mission.startx-144)/1000.0*200)+100-2, 200-(trunc((mission.starty-144)/1000.0*200))+100-2,
                          trunc((mission.startx-144)/1000.0*200)+100+2, 200-(trunc((mission.starty-144)/1000.0*200))+100+2);
    Image2.Canvas.Pen.Color:=$FF0000;
    for i:=1 to mission.tanknum do begin
      Image2.Canvas.Pixels[trunc((mission.tanks[i].x-144)/1000.0*200)+100, 200-(trunc((mission.tanks[i].y-144)/1000.0*200)+100)]:=$000000;
    end;
    Image2.Canvas.Pen.Color:=$000000;
    for i:=1 to mission.housenum do begin
      Image2.Canvas.Pixels[trunc((mission.houses[i].x-144)/1000.0*200)+100, 200-(trunc((mission.houses[i].y-144)/1000.0*200)+100)]:=$000000;
    end;
  end;
  {big map}
  Image1.Canvas.Pen.Color:=$FFFFFF;
  Image1.Canvas.Brush.Color:=$FFFFFF;
  Image1.Canvas.Rectangle(0,0,400,400);
  for i:=1 to mission.waynum do begin
    if mission.ways[i].typ=0 then Image1.Canvas.Pen.width:=10;
    if mission.ways[i].typ>0 then Image1.Canvas.Pen.width:=3;
    Image1.Canvas.Pen.Color:=$D0FFD0;
    if (select.typ=11)and(select.obj=i) then Image1.Canvas.Pen.Color:=$000000;
    Image1.Canvas.MoveTo(trunc((mission.ways[i].x1-view.x)*view.zoom/255.0*400)+200, -trunc((mission.ways[i].y1-view.y)*view.zoom/255.0*400)+200);
    Image1.Canvas.LineTo(trunc((mission.ways[i].x2-view.x)*view.zoom/255.0*400)+200, -trunc((mission.ways[i].y2-view.y)*view.zoom/255.0*400)+200);
  end;
  Image1.Canvas.Pen.width:=1;
  Image1.Canvas.Pen.Color:=$0000FF;
  Image1.Canvas.Brush.Color:=$0000FF;
  Image1.Canvas.Ellipse(trunc((mission.startx-view.x)*view.zoom/255.0*400)+200-4, 200-(trunc((mission.starty-view.y)*view.zoom/255.0*400)-4),
                        trunc((mission.startx-view.x)*view.zoom/255.0*400)+200+4, 200-(trunc((mission.starty-view.y)*view.zoom/255.0*400)+4));
  for i:=1 to mission.tanknum do begin
    if mission.tanks[i].owner=0 then Image1.Canvas.Pen.Color:=$FF0000;
    if mission.tanks[i].owner=1 then Image1.Canvas.Pen.Color:=$0000FF;
    if mission.tanks[i].owner>1 then Image1.Canvas.Pen.Color:=$00FF00;
    if (select.typ=8)and(select.obj=i) then Image1.Canvas.Pen.Color:=$000000;
    DrawQuad(mission.tanks[i].x,mission.tanks[i].y, 0,1,2);
  end;
  for i:=1 to mission.housenum do begin
    if mission.houses[i].owner=0 then Image1.Canvas.Pen.Color:=$FF0000;
    if mission.houses[i].owner=1 then Image1.Canvas.Pen.Color:=$0000FF;
    if mission.houses[i].owner>1 then Image1.Canvas.Pen.Color:=$00FF00;
    if (select.typ=10)and(select.obj=i) then Image1.Canvas.Pen.Color:=$000000;
    if mission.houses[i].typ<10 then begin
      xsize:=2;
      ysize:=2;
    end else begin
      xsize:=1;
      ysize:=2;
    end;
    DrawQuad(mission.houses[i].x,mission.houses[i].y, mission.houses[i].a,xsize,ysize);
  end;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if inner then begin
    view.x:=X/200.0*255.0;
    view.y:=((200-Y)/200.0*255.0);
  end else begin
    view.x:=(X-100)/200.0*1000.0+144;
    view.y:=((200-Y)-100)/200.0*1000.0+144;
  end;
  Form1.Paint;
end;

procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Shift=[ssLeft] then begin
    if inner then begin
      view.x:=X/200.0*255.0;
      view.y:=((200-Y)/200.0*255.0);
    end else begin
      view.x:=(X-100)/200.0*1000.0+144;
      view.y:=((200-Y)-100)/200.0*1000.0+144;
    end;
    Form1.Paint;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  inner:=true;
  Form1.Paint;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  inner:=false;
  Form1.Paint;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveMission;
end;

function min(a, b:single):single;
begin
  if a<b then min:=a else min:=b;
end;

function max(a, b:single):single;
begin
  if a>b then max:=a else max:=b;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  mx,my:single;
  i:integer;
  wayhit:boolean;
begin
  mx:=((X-200)/400.0*255.0/view.zoom)+view.x;
  my:=(((400-Y)-200)/400.0*255.0/view.zoom)+view.y;
  if Button=mbLeft then begin
    drag.x:=mx;
    drag.y:=my;
    drag.left:=true;
  end;
  if Button=mbRight then begin
    drag.x:=mx;
    drag.y:=my;
    drag.right:=true;
  end;
  wayhit:=false;
  if (select.typ=11) then begin
    if (abs(mission.ways[select.obj].x1-mission.ways[select.obj].x2)>
        abs(mission.ways[select.obj].y1-mission.ways[select.obj].y2)) then begin
      if (mission.ways[select.obj].x2-mission.ways[select.obj].x1<>0)
      and(abs(my-(mission.ways[select.obj].y1+(mission.ways[select.obj].y2-mission.ways[select.obj].y1)*((mx-mission.ways[select.obj].x1)/(mission.ways[select.obj].x2-mission.ways[select.obj].x1))))<1)
      and(mx>min(mission.ways[select.obj].x1,mission.ways[select.obj].x2))
      and(mx<max(mission.ways[select.obj].x1,mission.ways[select.obj].x2)) then begin
        wayhit:=true;
      end;
    end else begin
      if (mission.ways[select.obj].y2-mission.ways[select.obj].y1<>0)
      and(abs(mx-(mission.ways[select.obj].x1+(mission.ways[select.obj].x2-mission.ways[select.obj].x1)*((my-mission.ways[select.obj].y1)/(mission.ways[select.obj].y2-mission.ways[select.obj].y1))))<1)
      and(my>min(mission.ways[select.obj].y1,mission.ways[select.obj].y2))
      and(my<max(mission.ways[select.obj].y1,mission.ways[select.obj].y2)) then begin
        wayhit:=true;
      end;
    end;
  end;
  if ((select.typ=8)and(abs(mx-mission.tanks[select.obj].x)<1)and(abs(my-mission.tanks[select.obj].y)<1))
  or ((select.typ=10)and(abs(mx-mission.houses[select.obj].x)<1)and(abs(my-mission.houses[select.obj].y)<1))
  or (wayhit) then begin
  end else begin
    select.typ:=-1;
    for i:=1 to mission.waynum do begin
      if (abs(mission.ways[i].x1-mission.ways[i].x2)>
          abs(mission.ways[i].y1-mission.ways[i].y2)) then begin
        if (mission.ways[i].x2-mission.ways[i].x1<>0)
        and(abs(my-(mission.ways[i].y1+(mission.ways[i].y2-mission.ways[i].y1)*((mx-mission.ways[i].x1)/(mission.ways[i].x2-mission.ways[i].x1))))<1)
        and(mx>min(mission.ways[i].x1,mission.ways[i].x2))
        and(mx<max(mission.ways[i].x1,mission.ways[i].x2)) then begin
          select.typ:=11;
          select.obj:=i;
        end;
      end else begin
        if (mission.ways[i].y2-mission.ways[i].y1<>0)
        and(abs(mx-(mission.ways[i].x1+(mission.ways[i].x2-mission.ways[i].x1)*((my-mission.ways[i].y1)/(mission.ways[i].y2-mission.ways[i].y1))))<1)
        and(my>min(mission.ways[i].y1,mission.ways[i].y2))
        and(my<max(mission.ways[i].y1,mission.ways[i].y2)) then begin
          select.typ:=11;
          select.obj:=i;
        end;
      end;
      if (mission.ways[i].x1=mission.ways[i].x2)
      and(mission.ways[i].y1=mission.ways[i].y2)
      and(abs(mx-mission.ways[i].x1)<1)
      and(abs(my-mission.ways[i].y1)<1) then begin
        select.typ:=11;
        select.obj:=i;
      end;
    end;
    for i:=1 to mission.housenum do begin
      if (abs(mx-mission.houses[i].x)<1)and(abs(my-mission.houses[i].y)<1) then begin
        select.typ:=10;
        select.obj:=i;
      end;
    end;
    for i:=1 to mission.tanknum do begin
      if (abs(mx-mission.tanks[i].x)<1)and(abs(my-mission.tanks[i].y)<1) then begin
        select.typ:=8;
        select.obj:=i;
      end;
    end;
    initinput;
  end;
  Form1.Paint;
end;

function check(str:string):boolean;
var
  i:integer;
begin
  if length(str)>0 then begin
    for i:=1 to length(str) do begin
      if (not(str[i] in ['0'..'9']))and(not(str[i]=','))
      and(not(str[i]='.'))and(not(str[i]='-')) then begin
        check:=false;
        exit;
      end;
    end;
  end else begin
    check:=false;
    exit;
  end;
  check:=true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SaveMission;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  SaveMission;
  LoadMission(Edit1.Text);
  Form1.Paint;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if select.typ=5 then begin
    if CheckBox1.Checked then begin
      mission.goal.killall:=1;
    end else begin
      mission.goal.killall:=-1;
    end;
  end;
  if select.typ=8 then begin
    if CheckBox1.Checked then begin
      mission.tanks[select.obj].noorders:=1;
    end else begin
      mission.tanks[select.obj].noorders:=-1;
    end;
  end;
  if select.typ=10 then begin
    if CheckBox1.Checked then begin
      mission.houses[select.obj].noorders:=1;
    end else begin
      mission.houses[select.obj].noorders:=-1;
    end;
  end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if select.typ=5 then begin
    if CheckBox2.Checked then begin
      mission.goal.location:=1;
    end else begin
      mission.goal.location:=-1;
    end;
  end;
  if select.typ=8 then begin
    if CheckBox2.Checked then begin
      mission.tanks[select.obj].nogoal:=1;
    end else begin
      mission.tanks[select.obj].nogoal:=-1;
    end;
  end;
  if select.typ=10 then begin
    if CheckBox2.Checked then begin
      mission.houses[select.obj].nogoal:=1;
    end else begin
      mission.houses[select.obj].nogoal:=-1;
    end;
  end;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if select.typ=5 then begin
    if CheckBox3.Checked then begin
      mission.goal.killlocation:=1;
    end else begin
      mission.goal.killlocation:=-1;
    end;
  end;
  if select.typ=8 then begin
    if CheckBox3.Checked then begin
      mission.tanks[select.obj].mustdie:=1;
    end else begin
      mission.tanks[select.obj].mustdie:=-1;
    end;
  end;
  if select.typ=10 then begin
    if CheckBox3.Checked then begin
      mission.houses[select.obj].mustdie:=1;
    end else begin
      mission.houses[select.obj].mustdie:=-1;
    end;
  end;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  if select.typ=5 then begin
    if CheckBox4.Checked then begin
      mission.goal.banlocation:=1;
    end else begin
      mission.goal.banlocation:=-1;
    end;
  end;
  if select.typ=8 then begin
    if CheckBox4.Checked then begin
      mission.tanks[select.obj].mustsurvive:=1;
    end else begin
      mission.tanks[select.obj].mustsurvive:=-1;
    end;
  end;
  if select.typ=10 then begin
    if CheckBox4.Checked then begin
      mission.houses[select.obj].mustsurvive:=1;
    end else begin
      mission.houses[select.obj].mustsurvive:=-1;
    end;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  select.typ:=1;
  initinput;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  select.typ:=3;
  initinput;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  select.typ:=7;
  initinput;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  select.typ:=9;
  initinput;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  select.typ:=5;
  initinput;
end;

procedure TForm1.Edit14Change(Sender: TObject);
begin
  if select.typ=1 then begin
    mission.name:=Form1.Edit14.Text;
  end;
  if select.typ=3 then begin
    mission.orders[1]:=Form1.Edit14.Text;
  end;
  if select.typ=6 then begin
    mission.next:=Form1.Edit14.Text;
  end;
end;

procedure TForm1.Edit15Change(Sender: TObject);
begin
  if select.typ=3 then begin
    mission.orders[2]:=Form1.Edit15.Text;
  end;
end;

procedure TForm1.Edit16Change(Sender: TObject);
begin
  if select.typ=3 then begin
    mission.orders[3]:=Form1.Edit16.Text;
  end;
end;

procedure TForm1.Edit17Change(Sender: TObject);
begin
  if select.typ=3 then begin
    mission.orders[4]:=Form1.Edit17.Text;
  end;
end;

procedure TForm1.Edit18Change(Sender: TObject);
begin
  if select.typ=3 then begin
    mission.orders[5]:=Form1.Edit18.Text;
  end;
end;

procedure TForm1.Edit19Change(Sender: TObject);
begin
  if select.typ=3 then begin
    mission.orders[6]:=Form1.Edit19.Text;
  end;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit2.Text) then begin
        mission.goal.mustsurvive:=StrToFloat(Form1.Edit2.Text);
      end else begin
//        Form1.Edit2.Text:=FloatToStr((mission.goal.mustsurvive));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit2.Text) then begin
        mission.light.x1:=StrToFloat(Form1.Edit2.Text);
      end else begin
//        Form1.Edit2.Text:=FloatToStr((mission.light.x1));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit2.Text) then begin
        mission.tanks[select.obj].owner:=StrToFloat(Form1.Edit2.Text);
      end else begin
//        Form1.Edit2.Text:=FloatToStr((mission.tanks[select.obj].owner));
      end;
    end;
    if select.typ=9 then begin
      if check(Form1.Edit2.Text) then begin
        mission.startx:=StrToFloat(Form1.Edit2.Text);
      end else begin
//        Form1.Edit2.Text:=FloatToStr((mission.startx));
      end;
    end;
    if select.typ=10 then begin
      if check(Form1.Edit2.Text) then begin
        mission.houses[select.obj].owner:=StrToFloat(Form1.Edit2.Text);
      end else begin
//        Form1.Edit2.Text:=FloatToStr((mission.houses[select.obj].owner));
      end;
    end;
    if select.typ=11 then begin
      if check(Form1.Edit2.Text) then begin
        mission.ways[select.obj].x1:=StrToFloat(Form1.Edit2.Text);
      end else begin
//        Form1.Edit2.Text:=FloatToStr((mission.ways[select.obj].x1));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit3.Text) then begin
        mission.goal.mustdie:=StrToFloat(Form1.Edit3.Text);
      end else begin
//        Form1.Edit3.Text:=FloatToStr((mission.goal.mustdie));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit3.Text) then begin
        mission.light.x2:=StrToFloat(Form1.Edit3.Text);
      end else begin
//        Form1.Edit3.Text:=FloatToStr((mission.light.x2));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit3.Text) then begin
        mission.tanks[select.obj].typ:=StrToFloat(Form1.Edit3.Text);
      end else begin
//        Form1.Edit3.Text:=FloatToStr((mission.tanks[select.obj].typ));
      end;
    end;
    if select.typ=9 then begin
      if check(Form1.Edit3.Text) then begin
        mission.starty:=StrToFloat(Form1.Edit3.Text);
      end else begin
//        Form1.Edit3.Text:=FloatToStr((mission.starty));
      end;
    end;
    if select.typ=10 then begin
      if check(Form1.Edit3.Text) then begin
        mission.houses[select.obj].typ:=StrToFloat(Form1.Edit3.Text);
      end else begin
//        Form1.Edit3.Text:=FloatToStr((mission.houses[select.obj].typ));
      end;
    end;
    if select.typ=11 then begin
      if check(Form1.Edit3.Text) then begin
        mission.ways[select.obj].x2:=StrToFloat(Form1.Edit3.Text);
      end else begin
//        Form1.Edit3.Text:=FloatToStr((mission.ways[select.obj].x2));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit4.Text) then begin
        mission.goal.lx:=StrToFloat(Form1.Edit4.Text);
      end else begin
//        Form1.Edit4.Text:=FloatToStr((mission.goal.lx));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit4.Text) then begin
        mission.light.y1:=StrToFloat(Form1.Edit4.Text);
      end else begin
//        Form1.Edit4.Text:=FloatToStr((mission.light.y1));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit4.Text) then begin
        mission.tanks[select.obj].x:=StrToFloat(Form1.Edit4.Text);
      end else begin
//        Form1.Edit4.Text:=FloatToStr((mission.tanks[select.obj].x));
      end;
    end;
    if select.typ=10 then begin
      if check(Form1.Edit4.Text) then begin
        mission.houses[select.obj].x:=StrToFloat(Form1.Edit4.Text);
      end else begin
//        Form1.Edit4.Text:=FloatToStr((mission.houses[select.obj].x));
      end;
    end;
    if select.typ=11 then begin
      if check(Form1.Edit4.Text) then begin
        mission.ways[select.obj].y1:=StrToFloat(Form1.Edit4.Text);
      end else begin
//        Form1.Edit4.Text:=FloatToStr((mission.ways[select.obj].y1));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit5Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit5.Text) then begin
        mission.goal.ly:=StrToFloat(Form1.Edit5.Text);
      end else begin
//        Form1.Edit5.Text:=FloatToStr((mission.goal.ly));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit5.Text) then begin
        mission.light.y2:=StrToFloat(Form1.Edit5.Text);
      end else begin
//        Form1.Edit5.Text:=FloatToStr((mission.light.y2));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit5.Text) then begin
        mission.tanks[select.obj].y:=StrToFloat(Form1.Edit5.Text);
      end else begin
//        Form1.Edit5.Text:=FloatToStr((mission.tanks[select.obj].y));
      end;
    end;
    if select.typ=10 then begin
      if check(Form1.Edit5.Text) then begin
        mission.houses[select.obj].y:=StrToFloat(Form1.Edit5.Text);
      end else begin
//        Form1.Edit5.Text:=FloatToStr((mission.houses[select.obj].y));
      end;
    end;
    if select.typ=11 then begin
      if check(Form1.Edit5.Text) then begin
        mission.ways[select.obj].y2:=StrToFloat(Form1.Edit5.Text);
      end else begin
//        Form1.Edit5.Text:=FloatToStr((mission.ways[select.obj].y2));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit6.Text) then begin
        mission.goal.lr:=StrToFloat(Form1.Edit6.Text);
      end else begin
//        Form1.Edit6.Text:=FloatToStr((mission.goal.lr));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit6.Text) then begin
        mission.light.z1:=StrToFloat(Form1.Edit6.Text);
      end else begin
//        Form1.Edit6.Text:=FloatToStr((mission.light.z1));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit6.Text) then begin
        mission.tanks[select.obj].target:=StrToFloat(Form1.Edit6.Text);
      end else begin
//        Form1.Edit6.Text:=FloatToStr((mission.tanks[select.obj].target));
      end;
    end;
    if select.typ=10 then begin
      if check(Form1.Edit6.Text) then begin
        mission.houses[select.obj].a:=StrToFloat(Form1.Edit6.Text);
      end else begin
//        Form1.Edit6.Text:=FloatToStr((mission.houses[select.obj].a/(2*PI)*255.0));
      end;
    end;
    if select.typ=11 then begin
      if check(Form1.Edit6.Text) then begin
        mission.ways[select.obj].typ:=StrToFloat(Form1.Edit6.Text);
      end else begin
//        Form1.Edit6.Text:=FloatToStr((mission.ways[select.obj].typ));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit7Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit7.Text) then begin
        mission.goal.kx:=StrToFloat(Form1.Edit7.Text);
      end else begin
//        Form1.Edit7.Text:=FloatToStr((mission.goal.kx));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit7.Text) then begin
        mission.light.z2:=StrToFloat(Form1.Edit7.Text);
      end else begin
//        Form1.Edit7.Text:=FloatToStr((mission.light.z2));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit7.Text) then begin
        mission.tanks[select.obj].tx:=StrToFloat(Form1.Edit7.Text);
      end else begin
//        Form1.Edit7.Text:=FloatToStr((mission.tanks[select.obj].tx));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit8Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit8.Text) then begin
        mission.goal.ky:=StrToFloat(Form1.Edit8.Text);
      end else begin
//        Form1.Edit8.Text:=FloatToStr((mission.goal.ky));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit8.Text) then begin
        mission.light.r1:=StrToFloat(Form1.Edit8.Text);
      end else begin
//        Form1.Edit8.Text:=FloatToStr((mission.light.r1*255.0));
      end;
    end;
    if select.typ=8 then begin
      if check(Form1.Edit8.Text) then begin
        mission.tanks[select.obj].ty:=StrToFloat(Form1.Edit8.Text);
      end else begin
//        Form1.Edit8.Text:=FloatToStr((mission.tanks[select.obj].ty));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit9Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit9.Text) then begin
        mission.goal.kr:=StrToFloat(Form1.Edit9.Text);
      end else begin
//        Form1.Edit9.Text:=FloatToStr((mission.goal.kr));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit9.Text) then begin
        mission.light.r2:=StrToFloat(Form1.Edit9.Text);
      end else begin
//        Form1.Edit9.Text:=FloatToStr((mission.light.r2*255.0));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit10Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit10.Text) then begin
        mission.goal.bx:=StrToFloat(Form1.Edit10.Text);
      end else begin
//        Form1.Edit10.Text:=FloatToStr((mission.goal.bx));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit10.Text) then begin
        mission.light.g1:=StrToFloat(Form1.Edit10.Text);
      end else begin
//        Form1.Edit10.Text:=FloatToStr((mission.light.g1*255.0));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit11Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit11.Text) then begin
        mission.goal.by:=StrToFloat(Form1.Edit11.Text);
      end else begin
//        Form1.Edit11.Text:=FloatToStr((mission.goal.by));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit11.Text) then begin
        mission.light.g2:=StrToFloat(Form1.Edit11.Text);
      end else begin
//        Form1.Edit11.Text:=FloatToStr((mission.light.g2*255.0));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit12Change(Sender: TObject);
begin
    if select.typ=5 then begin
      if check(Form1.Edit12.Text) then begin
        mission.goal.br:=StrToFloat(Form1.Edit12.Text);
      end else begin
//        Form1.Edit12.Text:=FloatToStr((mission.goal.br));
      end;
    end;
    if select.typ=7 then begin
      if check(Form1.Edit12.Text) then begin
        mission.light.b1:=StrToFloat(Form1.Edit12.Text);
      end else begin
//        Form1.Edit12.Text:=FloatToStr((mission.light.b1*255.0));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Edit13Change(Sender: TObject);
begin
    if select.typ=7 then begin
      if check(Form1.Edit13.Text) then begin
        mission.light.b2:=StrToFloat(Form1.Edit13.Text);
      end else begin
//        Form1.Edit13.Text:=FloatToStr((mission.light.b2*255.0));
      end;
    end;
  Form1.Paint;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  inc(mission.tanknum);
  mission.tanks[mission.tanknum].x:=144;
  mission.tanks[mission.tanknum].y:=144;
  mission.tanks[mission.tanknum].owner:=0;
  mission.tanks[mission.tanknum].typ:=0;
  mission.tanks[mission.tanknum].target:=-1;
  mission.tanks[mission.tanknum].tx:=0;
  mission.tanks[mission.tanknum].ty:=0;
  mission.tanks[mission.tanknum].noorders:=-1;
  mission.tanks[mission.tanknum].nogoal:=-1;
  mission.tanks[mission.tanknum].mustdie:=-1;
  mission.tanks[mission.tanknum].mustsurvive:=-1;
  select.typ:=8;
  select.obj:=mission.tanknum;
  Form1.Paint;
  initinput;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  inc(mission.housenum);
  mission.houses[mission.housenum].x:=144;
  mission.houses[mission.housenum].y:=144;
  mission.houses[mission.housenum].a:=0;
  mission.houses[mission.housenum].owner:=0;
  mission.houses[mission.housenum].typ:=0;
  mission.houses[mission.housenum].noorders:=-1;
  mission.houses[mission.housenum].nogoal:=-1;
  mission.houses[mission.housenum].mustdie:=-1;
  mission.houses[mission.housenum].mustsurvive:=-1;
  select.typ:=10;
  select.obj:=mission.housenum;
  Form1.Paint;
  initinput;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  inc(mission.waynum);
  mission.ways[mission.waynum].x1:=144;
  mission.ways[mission.waynum].y1:=144;
  mission.ways[mission.waynum].x2:=160;
  mission.ways[mission.waynum].y2:=160;
  mission.ways[mission.waynum].typ:=0;
  select.typ:=11;
  select.obj:=mission.waynum;
  Form1.Paint;
  initinput;
end;

procedure TForm1.Button13Click(Sender: TObject);
var i:integer;
begin
  if select.typ=8 then begin
    for i:=select.obj+1 to mission.tanknum do begin
      mission.tanks[i-1]:=mission.tanks[i];
    end;
    dec(mission.tanknum);
  end;
  if select.typ=10 then begin
    for i:=select.obj+1 to mission.housenum do begin
      mission.houses[i-1]:=mission.houses[i];
    end;
    dec(mission.housenum);
  end;
  if select.typ=11 then begin
    for i:=select.obj+1 to mission.waynum do begin
      mission.ways[i-1]:=mission.ways[i];
    end;
    dec(mission.waynum);
  end;
  select.typ:=-1;
  Form1.Paint;
end;

procedure TForm1.Button14Click(Sender: TObject);
var i:integer;
begin
  mission.fname:=Form1.Edit1.Text;
  mission.ordlen:=0;
  for i:=1 to 6 do mission.orders[i]:='';
  mission.tanknum:=0;
  mission.housenum:=0;
  mission.waynum:=0;
  mission.next:='';
  mission.name:='';
  mission.startx:=144;
  mission.starty:=144;
  mission.light.x1:=0;
  mission.light.y1:=0;
  mission.light.z1:=1;
  mission.light.r1:=0;
  mission.light.g1:=0.35;
  mission.light.b1:=0.55;
  mission.light.x2:=1;
  mission.light.y2:=0;
  mission.light.z2:=0.5;
  mission.light.r2:=0.75;
  mission.light.g2:=0.25;
  mission.light.b2:=0.2;
  mission.goal.killall:=1;
  mission.goal.mustsurvive:=-1;
  mission.goal.mustdie:=-1;
  mission.goal.location:=-1;
  mission.goal.killlocation:=-1;
  mission.goal.banlocation:=-1;
  mission.goal.lx:=0;
  mission.goal.ly:=0;
  mission.goal.lr:=0;
  mission.goal.kx:=0;
  mission.goal.ky:=0;
  mission.goal.kr:=0;
  mission.goal.bx:=0;
  mission.goal.by:=0;
  mission.goal.br:=0;
  SaveMission;
  select.typ:=-1;
  view.x:=144;
  view.y:=144;
  initinput;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  mx,my:single;
  dragl, dragr:boolean;
begin
  mx:=((X-200)/400.0*255.0/view.zoom)+view.x;
  my:=(((400-Y)-200)/400.0*255.0/view.zoom)+view.y;
  if Shift<>[ssLeft] then drag.left:=false;
  if Shift<>[ssRight] then drag.right:=false;
  dragl:=false;
  dragr:=false;
  if (drag.left)and((abs(mx-drag.x)>0.25)or(abs(my-drag.y)>0.25)) then begin
    dragl:=true;
    drag.x:=-10000;
    drag.y:=-10000;
  end;
  if (drag.right)and((abs(mx-drag.x)>0.25)or(abs(my-drag.y)>0.25)) then begin
    dragr:=true;
    drag.x:=-10000;
    drag.y:=-10000;
  end;
  if Shift=[ssLeft] then begin
    if (select.typ=8)and(dragl) then begin
      mission.tanks[select.obj].x:=mx;
      mission.tanks[select.obj].y:=my;
    end;
    if (select.typ=10)and(dragl) then begin
      mission.houses[select.obj].x:=mx;
      mission.houses[select.obj].y:=my;
    end;
    if (select.typ=11)and(dragl) then begin
      mission.ways[select.obj].x1:=mx;
      mission.ways[select.obj].y1:=my;
    end;
  end;
  if Shift=[ssRight] then begin
    if (select.typ=11)and(dragr) then begin
      mission.ways[select.obj].x2:=mx;
      mission.ways[select.obj].y2:=my;
    end;
  end;
  Form1.Paint;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  select.typ:=6;
  initinput;
end;

end.
